Open CASCADE Technology: Select3D_SensitiveEntity Class Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions | Protected Member Functions
Select3D_SensitiveEntity Class Referenceabstract

Abstract framework to define 3D sensitive entities. As the selection process uses the principle of a projection of 3D shapes onto a 2D view where nearness to a rectangle determines whether a shape is picked or not, all 3D shapes need to be converted into 2D ones in order to be selected. More...

`#include <Select3D_SensitiveEntity.hxx>`

Inheritance diagram for Select3D_SensitiveEntity:
[legend]

## Public Member Functions
virtual Handle< Select3D_SensitiveEntity > | GetConnected ()
| Originally this method intended to return sensitive entity with new location aLocation, but currently sensitive entities do not hold a location, instead HasLocation() and Location() methods call corresponding entity owner's methods. Thus all entities returned by GetConnected() share the same location propagated from corresponding selectable object. You must redefine this function for any type of sensitive entity which can accept another connected sensitive entity.//can be connected to another sensitive entity. More...
virtual Standard_Boolean | Matches (SelectBasics_SelectingVolumeManager &theMgr, SelectBasics_PickResult &thePickResult) Standard_OVERRIDE
| Checks whether sensitive overlaps current selecting volume. Stores minimum depth, distance to center of geometry and closest point detected into thePickResult. More...
virtual Standard_Integer | NbSubElements ()=0
| Returns the number of sub-entities or elements in sensitive entity. Is used to determine if entity is complex and needs to pre-build BVH at the creation of sensitive entity step or is light-weighted so the tree can be build on demand with unnoticeable delay. More...
virtual Select3D_BndBox3d | BoundingBox ()=0
| Returns bounding box of a sensitive with transformation applied. More...
virtual gp_Pnt | CenterOfGeometry () const =0
| Returns center of a sensitive with transformation applied. More...
virtual void | BVH () Standard_OVERRIDE
| Builds BVH tree for a sensitive if needed. More...
virtual void | Clear () Standard_OVERRIDE
| Clears up all resources and memory. More...
virtual Standard_Boolean | HasInitLocation () const Standard_OVERRIDE
| Returns true if the shape corresponding to the entity has init location. More...
virtual gp_Trsf | InvInitLocation () const
| Returns inversed location transformation matrix if the shape corresponding to this entity has init location set. Otherwise, returns identity matrix. More...
Public Member Functions inherited from SelectBasics_SensitiveEntity
virtual void | Set (const Handle< SelectBasics_EntityOwner > &theOwnerId)
| Sets owner of the entity. More...
const Handle< SelectBasics_EntityOwner > & | OwnerId () const
| Returns pointer to owner of the entity. More...
void | SetSensitivityFactor (const Standard_Integer theSensFactor)
| Allows to manage the sensitivity of the entity. More...
Standard_Integer | SensitivityFactor () const
| allows a better sensitivity for a specific entity in selection algorithms useful for small sized entities. More...
Public Member Functions inherited from MMgt_TShared
virtual void | Delete () const
| Memory deallocator for transient classes. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Protected Member Functions
| Select3D_SensitiveEntity (const Handle< SelectBasics_EntityOwner > &theOwnerId)
Protected Member Functions inherited from SelectBasics_SensitiveEntity
| SelectBasics_SensitiveEntity (const Handle< SelectBasics_EntityOwner > &theOwnerId, const Standard_Integer theSensFactor=2)

## Additional Inherited Members
Protected Attributes inherited from SelectBasics_SensitiveEntity
Handle< SelectBasics_EntityOwner > | myOwnerId

## Detailed Description

Abstract framework to define 3D sensitive entities. As the selection process uses the principle of a projection of 3D shapes onto a 2D view where nearness to a rectangle determines whether a shape is picked or not, all 3D shapes need to be converted into 2D ones in order to be selected.

## Constructor & Destructor Documentation

Select3D_SensitiveEntity::Select3D_SensitiveEntity | ( | const Handle< SelectBasics_EntityOwner > & | theOwnerId | ) |
| protected

## Member Function Documentation

virtual Select3D_BndBox3d Select3D_SensitiveEntity::BoundingBox | ( |  | ) |
| pure virtual

Returns bounding box of a sensitive with transformation applied.

Implements SelectBasics_SensitiveEntity.

Implemented in Select3D_SensitiveGroup, Select3D_SensitiveTriangulation, Select3D_SensitiveSet, Select3D_SensitivePoly, Select3D_SensitiveFace, Select3D_SensitiveSegment, Select3D_SensitiveBox, Select3D_SensitiveTriangle, Select3D_InteriorSensitivePointSet, MeshVS_SensitivePolyhedron, Select3D_SensitivePoint, Select3D_SensitiveWire, and MeshVS_SensitiveMesh.

virtual void Select3D_SensitiveEntity::BVH | ( |  | ) |
| virtual

Builds BVH tree for a sensitive if needed.

Implements SelectBasics_SensitiveEntity.

Reimplemented in Select3D_SensitiveCircle, Select3D_SensitiveFace, and Select3D_SensitiveSet.

virtual gp_Pnt Select3D_SensitiveEntity::CenterOfGeometry | ( |  | ) | const
| pure virtual

Returns center of a sensitive with transformation applied.

Implemented in Select3D_SensitiveGroup, Select3D_SensitiveTriangulation, Select3D_SensitiveCircle, Select3D_SensitiveSet, Select3D_SensitivePoly, Select3D_SensitiveFace, Select3D_SensitiveTriangle, Select3D_SensitiveSegment, Select3D_InteriorSensitivePointSet, Select3D_SensitiveBox, MeshVS_SensitivePolyhedron, Select3D_SensitiveWire, Select3D_SensitivePoint, and MeshVS_SensitiveMesh.

virtual void Select3D_SensitiveEntity::Clear | ( |  | ) |
| virtual

Clears up all resources and memory.

Implements SelectBasics_SensitiveEntity.

Reimplemented in Select3D_SensitiveSet, and Select3D_SensitiveGroup.

virtual Handle< Select3D_SensitiveEntity > Select3D_SensitiveEntity::GetConnected | ( |  | ) |
| virtual

Originally this method intended to return sensitive entity with new location aLocation, but currently sensitive entities do not hold a location, instead HasLocation() and Location() methods call corresponding entity owner's methods. Thus all entities returned by GetConnected() share the same location propagated from corresponding selectable object. You must redefine this function for any type of sensitive entity which can accept another connected sensitive entity.//can be connected to another sensitive entity.

Reimplemented in Select3D_SensitiveCircle, Select3D_SensitiveGroup, Select3D_SensitiveTriangulation, Select3D_SensitiveFace, Select3D_SensitiveCurve, Select3D_SensitiveTriangle, Select3D_SensitiveSegment, Select3D_SensitiveBox, MeshVS_SensitivePolyhedron, Select3D_SensitiveWire, Select3D_SensitivePoint, and MeshVS_SensitiveMesh.

virtual Standard_Boolean Select3D_SensitiveEntity::HasInitLocation | ( |  | ) | const
| virtual

Returns true if the shape corresponding to the entity has init location.

Implements SelectBasics_SensitiveEntity.

Reimplemented in Select3D_SensitiveTriangulation.

virtual gp_Trsf Select3D_SensitiveEntity::InvInitLocation | ( |  | ) | const
| virtual

Returns inversed location transformation matrix if the shape corresponding to this entity has init location set. Otherwise, returns identity matrix.

Implements SelectBasics_SensitiveEntity.

Reimplemented in Select3D_SensitiveTriangulation.

virtual Standard_Boolean Select3D_SensitiveEntity::Matches | ( | SelectBasics_SelectingVolumeManager & | theMgr,
|  | SelectBasics_PickResult & | thePickResult
| ) |  |
| virtual

Checks whether sensitive overlaps current selecting volume. Stores minimum depth, distance to center of geometry and closest point detected into thePickResult.

Implements SelectBasics_SensitiveEntity.

Reimplemented in Select3D_SensitiveCircle, Select3D_SensitiveGroup, Select3D_SensitiveFace, Select3D_SensitiveSegment, Select3D_SensitiveSet, Select3D_SensitiveBox, MeshVS_SensitivePolyhedron, Select3D_SensitiveTriangle, and Select3D_SensitivePoint.

virtual Standard_Integer Select3D_SensitiveEntity::NbSubElements | ( |  | ) |
| pure virtual

Returns the number of sub-entities or elements in sensitive entity. Is used to determine if entity is complex and needs to pre-build BVH at the creation of sensitive entity step or is light-weighted so the tree can be build on demand with unnoticeable delay.

Implements SelectBasics_SensitiveEntity.

Implemented in Select3D_SensitiveGroup, Select3D_SensitiveFace, Select3D_SensitiveTriangulation, Select3D_InteriorSensitivePointSet, Select3D_SensitiveTriangle, Select3D_SensitivePoly, MeshVS_SensitivePolyhedron, Select3D_SensitiveSegment, Select3D_SensitiveBox, Select3D_SensitiveWire, Select3D_SensitivePoint, and MeshVS_SensitiveMesh.

The documentation for this class was generated from the following file:

- Select3D_SensitiveEntity.hxx